// ZLibTestDlg.cpp : implementation file
// Author: Chong-Wei CHEN
// Time: 09-08-2001
// Demostration of the zlibst.lib

#include "stdafx.h"
#include "ZLibTest.h"
#include "ZLibTestDlg.h"
#include "zlib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void BrowseFile(CEdit &Edit, BOOL bOpenFileDialog, DWORD dwFlags, UINT nFilterID)
{
	// TODO: Add your control notification handler code here
	CString strFileName;

	Edit.GetWindowText(strFileName);

	CFileDialog	FileDialog(bOpenFileDialog, NULL, (LPCTSTR)strFileName, dwFlags, CString((LPCSTR)nFilterID));

	if (FileDialog.DoModal() == IDOK)	{ 
		strFileName = FileDialog.GetPathName();
		Edit.SetWindowText(strFileName);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CZLibTestDlg dialog

CZLibTestDlg::CZLibTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZLibTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZLibTestDlg)
	m_strSrcFile = _T("");
	m_strTarFile = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CZLibTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZLibTestDlg)
	DDX_Control(pDX, IDC_TARGET_FILE_EDIT, m_TarFileEdit);
	DDX_Control(pDX, IDC_SOURCE_FILE_EDIT, m_SrcFileEdit);
	DDX_Text(pDX, IDC_SOURCE_FILE_EDIT, m_strSrcFile);
	DDX_Text(pDX, IDC_TARGET_FILE_EDIT, m_strTarFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CZLibTestDlg, CDialog)
	//{{AFX_MSG_MAP(CZLibTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MORE_SRC_BUTTON, OnMoreSrcButton)
	ON_BN_CLICKED(IDC_MORE_TAR_BUTTON, OnMoreTarButton)
	ON_BN_CLICKED(IDC_COMPRESS_BUTTON, OnCompressButton)
	ON_BN_CLICKED(IDC_UNCOMPRESS_BUTTON, OnUncompressButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZLibTestDlg message handlers

BOOL CZLibTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CZLibTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CZLibTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CZLibTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CZLibTestDlg::OnMoreSrcButton() 
{
	// TODO: Add your control notification handler code here
	BrowseFile(m_SrcFileEdit, TRUE, OFN_FILEMUSTEXIST, IDS_FILTER);
}

void CZLibTestDlg::OnMoreTarButton() 
{
	// TODO: Add your control notification handler code here
	BrowseFile(m_TarFileEdit, FALSE, OFN_OVERWRITEPROMPT, IDS_FILTER);	
}

void CZLibTestDlg::OnCompressButton() 
{
	// TODO: Add your control notification handler code here
	CFile SrcFile, DstFile;
	ULONG uSrcLen, uMaxDstLen, uDstLen, uBufCount, uBufLeft, i;
	BYTE *pSrcBuf = NULL, *pDstBuf = NULL;
	BOOL bSuccess = FALSE;

	UpdateData();

	uSrcLen = MAX_BUFFER_SIZE;
	pSrcBuf = new BYTE[uSrcLen];	// malloc buffer
	uDstLen = uMaxDstLen = (ULONG)((uSrcLen+12)*1.01);
	pDstBuf = new BYTE[uDstLen];
	try	{
		if (SrcFile.Open(m_strSrcFile, CFile::modeRead | CFile::shareDenyWrite))	{
			if (DstFile.Open(m_strTarFile, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive))	{
				uBufCount = SrcFile.GetLength() / uSrcLen;
				uBufLeft = SrcFile.GetLength() % uSrcLen;
				for (i = 0; i < uBufCount; i++)	{
					SrcFile.Read(pSrcBuf, uSrcLen);
					uDstLen = uMaxDstLen;
					if (compress2(pDstBuf, &uDstLen, pSrcBuf, uSrcLen, Z_BEST_COMPRESSION) != Z_OK)
						throw CString(_T("Error in compressing file ")) + m_strSrcFile;
					DstFile.Write(&uSrcLen, sizeof(uSrcLen));
					DstFile.Write(&uDstLen, sizeof(uDstLen));
					DstFile.Write(pDstBuf, uDstLen);
				}
				if (uBufLeft)	{
					SrcFile.Read(pSrcBuf, uBufLeft);
					uDstLen = uMaxDstLen;
					if (compress2(pDstBuf, &uDstLen, pSrcBuf, uBufLeft, Z_BEST_COMPRESSION) != Z_OK)
						throw CString(_T("Error in compressing file ")) + m_strSrcFile;
					DstFile.Write(&uSrcLen, sizeof(uSrcLen));
					DstFile.Write(&uDstLen, sizeof(uDstLen));
					DstFile.Write(pDstBuf, uDstLen);
				}
				bSuccess = TRUE;
				DstFile.Close();
			}
			SrcFile.Close();
		}
	}
	catch(CFileException *e)
	{
		e->ReportError();
		e->Delete();
	}
	catch(CString *str)
	{
		AfxMessageBox(*str);
	}
	if (pDstBuf != NULL)	delete pDstBuf;
	if (pSrcBuf != NULL)	delete pSrcBuf;
	if (bSuccess)	
		AfxMessageBox(_T("Compress file ") + m_strSrcFile + _T(" successfully!"));
	else	
		AfxMessageBox(_T("Fail to compress file ") + m_strSrcFile);
}

void CZLibTestDlg::OnUncompressButton() 
{
	// TODO: Add your control notification handler code here
	CFile SrcFile, DstFile;
	ULONG uSrcLen, uDstLen;
	BYTE *pSrcBuf = NULL, *pDstBuf = NULL;
	BOOL bSuccess = FALSE;

	UpdateData();

	try	{
		if (SrcFile.Open(m_strSrcFile, CFile::modeRead | CFile::shareDenyWrite))	{
			if (DstFile.Open(m_strTarFile, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive))	{
				while (TRUE)	{
					if (SrcFile.Read(&uSrcLen, sizeof(uSrcLen)) != sizeof(uSrcLen))	break;
					SrcFile.Read(&uDstLen, sizeof(uDstLen));

					if (pSrcBuf)	delete pSrcBuf;
					if (pDstBuf)	delete pDstBuf;

					pSrcBuf = new BYTE[uSrcLen];	// malloc buffer
					pDstBuf = new BYTE[uDstLen];
			
					SrcFile.Read(pDstBuf, uDstLen);
					if (uncompress (pSrcBuf, &uSrcLen, pDstBuf, uDstLen) != Z_OK)
						throw CString(_T("Error in decompressing file ")) + m_strSrcFile;
	
					DstFile.Write(pSrcBuf, uSrcLen);
				}
				bSuccess = TRUE;
				DstFile.Close();
			}
			SrcFile.Close();
		}
	}
	catch(CFileException *e)
	{
		e->ReportError();
		e->Delete();
	}
	catch(CString *str)
	{
		AfxMessageBox(*str);
	}
	if (pDstBuf != NULL)	delete pDstBuf;
	if (pSrcBuf != NULL)	delete pSrcBuf;
	if (bSuccess)	
		AfxMessageBox(_T("DeCompress file ") + m_strSrcFile + _T(" successfully!"));
	else	
		AfxMessageBox(_T("Fail to decompress file ") + m_strSrcFile);	
}
